<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright  2002 - 2008 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: sitemap_functions.php
| Version: 2.01
| Author: Arda Klda (SoulSmasher)
| Web: http://www.soulsmasher.net
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/

if (!defined("IN_FUSION") || !defined("DB_SITEMAPXML")) { die("Access Denied"); }

//for form functions
if (file_exists(INFUSIONS."sitemapxml/locale/".$settings['locale'].".php")) {
	include_once INFUSIONS."sitemapxml/locale/".$settings['locale'].".php";
} else {
	include_once INFUSIONS."sitemapxml/locale/English.php";
}
//for form functions

//for sitemap settings
$sitemapsettings=dbarray(dbquery("SELECT * FROM ".DB_SITEMAPXML));
//for sitemap settings

//bu fonksiyon kstl alanlarn forumda grnmn engellemek iin lazm, dz yelerin grebilecei ekilde ayarland
//this function is needed for accessibility on auto generated sitemap, because we don't want to make restricted areas show on xml, wo we ;)
function groupxmlaccess($field) {
	$res = "($field='0' OR $field='101')";
	return $res;
}


//sitemap.xml iin date fonksiyonu - date function for sitemap.xml for <lastmod> tags
function makexmldate($date) {
	//return date(DATE_ATOM,$date);
	return date('Y-m-d\TH:i:s',$date).substr_replace(date('O',$date),':',3,0); //for compatibility for old php versions
}

function generate_sitemapxml() {
global $settings,$sitemapsettings;
mt_srand((double)microtime()*1000000); //memoryde random iin yer ayarlyor

//ierik balyor burada yazlmaya
$content = "<?xml version='1.0' encoding='UTF-8'?>\n\n";
$content.= "<?xml-stylesheet type='text/xsl' href='".$settings['siteurl']."infusions/sitemapxml/sitemap.xsl'?>\n\n";
$content.= "<!-- generator='Google Sitemap Generator 2.0 By Arda Kilicdagi (SoulSmasher)' -->\n<!-- sitemap-generator-url='http://www.soulsmasher.net' sitemap-generator-version='2.0' -->\n
<!-- generated-on='".date("F j, Y g:i a")."' -->\n\n"; //ltfen copyright silmeyin zaten site haritasnda gzkmez bu yorum iindir, please don't delete this line, this is just a comment
$content.= "<urlset xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance' xsi:schemaLocation='http://www.sitemaps.org/schemas/sitemap/0.9 http://www.sitemaps.org/schemas/sitemap/0.9/sitemap.xsd' xmlns='http://www.sitemaps.org/schemas/sitemap/0.9'>\n\n";


//haberleri dizelim - News
$result=dbquery("SELECT news_subject, news_id, news_datestamp FROM ".DB_NEWS." WHERE ".groupxmlaccess('news_visibility')." AND (news_start='0'||news_start<=".time().") AND (news_end='0'||news_end>=".time().") AND news_draft='0' ORDER BY news_id DESC");
$rows = dbrows($result);
	if ($rows!=0) {
		while ($data = dbarray($result)) {
				$content.= "\t<url>\n";
				$content.= "\t\t<loc>".$settings['siteurl']."news.php?readmore=".$data['news_id']."</loc>\n";
				$content.= "\t\t<lastmod>".makexmldate($data['news_datestamp'])."</lastmod>\n";
				$content.= "\t\t<priority>".$sitemapsettings['news_priority']."</priority>\n";
				$content.= "\t\t<changefreq>".makechangefreq($sitemapsettings['news_changefreq'])."</changefreq>\n"; 
				$content.= "\t</url>\n";
		}
	}

//2.00 ile geldi , new with 2.00 - news cats - haber kategorileri
$result = dbquery("SELECT news_cat_id FROM ".DB_NEWS_CATS);
$rows=dbrows($result);
	if ($rows!=0) {
		while ($data=dbarray($result)) {
				$content.= "\t<url>\n";
				$content.= "\t\t<loc>".$settings['siteurl']."news_cats.php?cat_id=".$data['news_cat_id']."</loc>\n";
				$content.= "\t\t<priority>".$sitemapsettings['newscats_priority']."</priority>\n";
				$content.= "\t\t<changefreq>".makechangefreq($sitemapsettings['newscats_changefreq'])."</changefreq>\n"; 
				$content.= "\t</url>\n";
		}
	}

//inceleme kategorileri - Article Categories
$result = dbquery("SELECT article_cat_id FROM ".DB_ARTICLE_CATS." WHERE ".groupxmlaccess('article_cat_access')." ORDER BY article_cat_name ASC");
$rows = dbrows($result);
if ($rows!=0) {
	while ($data = dbarray($result)) {
				$content.= "\t<url>\n";
				$content.= "\t\t<loc>".$settings['siteurl']."articles.php?cat_id=".$data['article_cat_id']. "</loc>\n";
				$content.= "\t\t<priority>".$sitemapsettings['articlecats_priority']."</priority>\n";
				$content.= "\t\t<changefreq>".makechangefreq($sitemapsettings['articlecats_changefreq'])."</changefreq>\n";
				$content.= "\t</url>\n";
	}
}

//ncelemeler - Articles
$result = dbquery(
	"SELECT ta.article_id, ta.article_datestamp, tac.article_cat_id, tac.article_cat_access FROM ".DB_ARTICLES." ta
	INNER JOIN ".DB_ARTICLE_CATS." tac ON ta.article_cat=tac.article_cat_id
	".(iSUPERADMIN ? "" : "WHERE ".groupxmlaccess('article_cat_access'))." AND article_draft='0' ORDER BY article_datestamp DESC"
);
$rows = dbrows($result);
if ($rows!=0) {
	while ($data = dbarray($result)) {
				$content.= "\t<url>\n";
				$content.= "\t\t<loc>".$settings['siteurl']."readarticle.php?article_id=".$data['article_id']."</loc>\n";
				$content.= "\t\t<lastmod>".makexmldate($data['article_datestamp'])."</lastmod>\n";
				$content.= "\t\t<priority>".$sitemapsettings['articlecats_priority']."</priority>\n";
				$content.= "\t\t<changefreq>".makechangefreq($sitemapsettings['articles_changefreq'])."</changefreq>\n";
				$content.= "\t</url>\n";
	}
}

//zel sayfalar - Custom pages
$result = dbquery("SELECT * FROM ".DB_CUSTOM_PAGES." ORDER BY page_title ASC");
$rows = dbrows($result);
if ($rows!=0) {
	while ($data = dbarray($result)) {
				$content.= "\t<url>\n";
				$content.= "\t\t<loc>".$settings['siteurl']."viewpage.php?page_id=".$data['page_id']. "</loc>\n";
				$content.= "\t\t<priority>".$sitemapsettings['custompages_priority']."</priority>\n";
				$content.= "\t\t<changefreq>".makechangefreq($sitemapsettings['custompages_changefreq'])."</changefreq>\n";
				$content.= "\t</url>\n";
	}
}


//SSS kategorileri - FAQ Cats
$result = dbquery("SELECT faq_cat_id FROM ".DB_FAQ_CATS." ORDER BY faq_cat_name");
$rows = dbrows($result);
if ($rows!=0) {
	while ($data = dbarray($result)) {
				$content.= "\t<url>\n";
				$content.= "\t\t<loc>".$settings['siteurl']."faq.php?cat_id=".$data['faq_cat_id']. "</loc>\n";
				$content.= "\t\t<priority>".$sitemapsettings['faqcats_priority']."</priority>\n";
				$content.= "\t\t<changefreq>".makechangefreq($sitemapsettings['faqcats_changefreq'])."</changefreq>\n";
				$content.= "\t</url>\n";
	}
}

//download kategorileri - download cats
$result = dbquery("SELECT download_cat_id FROM ".DB_DOWNLOAD_CATS." WHERE ".groupxmlaccess('download_cat_access')." ORDER BY download_cat_name ASC");
$rows = dbrows($result);
if ($rows!=0) {
	while ($data = dbarray($result)) {
				$content.= "\t<url>\n";
				$content.= "\t\t<loc>".$settings['siteurl']."downloads.php?cat_id=".$data['download_cat_id']."</loc>\n";
				$content.= "\t\t<priority>".$sitemapsettings['downloadcats_priority']."</priority>\n";
				$content.= "\t\t<changefreq>".makechangefreq($sitemapsettings['downloadcats_changefreq'])."</changefreq>\n";
				$content.= "\t</url>\n";
	}
}

//dosyalar - downloads
$result = dbquery("SELECT download_cat,download_datestamp,download_id FROM ".DB_DOWNLOADS." ORDER BY download_datestamp DESC");
$rows = dbrows($result);
if ($rows!=0) {
	while ($data = dbarray($result)) {
				$content.= "\t<url>\n";
				$content.= "\t\t<loc>".$settings['siteurl']."downloads.php?cat_id=".$data['download_cat']."&amp;download_id=".$data['download_id']."</loc>\n";
				$content.= "\t\t<lastmod>".makexmldate($data['download_datestamp'])."</lastmod>\n";
				$content.= "\t\t<priority>".$sitemapsettings['downloads_priority']."</priority>\n";
				$content.= "\t\t<changefreq>".makechangefreq($sitemapsettings['downloads_changefreq'])."</changefreq>\n";
				$content.= "\t</url>\n";
	}
}

//web linki kategorileri - weblink cats
$result = dbquery("SELECT * FROM ".DB_WEBLINK_CATS." WHERE ".groupxmlaccess('weblink_cat_access')." ORDER BY weblink_cat_name");
$rows = dbrows($result);
if ($rows!=0) {
	while ($data = dbarray($result)) {
				$content.= "\t<url>\n";
				$content.= "\t\t<loc>".$settings['siteurl']."weblinks.php?cat_id=".$data['weblink_cat_id']. "</loc>\n";
				$content.= "\t\t<priority>".$sitemapsettings['weblinkcats_priority']."</priority>\n";
				$content.= "\t\t<changefreq>".makechangefreq($sitemapsettings['weblinkcars_changefreq'])."</changefreq>\n";
				$content.= "\t</url>\n";
	}
}

/* //i think it's bad for seo
//web linkleri - weblinks
$result = dbquery("SELECT weblink_cat_id FROM ".DB_WEBLINK_CATS." WHERE ".groupxmlaccess('weblink_cat_access')." ORDER BY weblink_cat_name");
$rows = dbrows($result);
if ($rows!=0) {
	while ($wdata=dbarray($result)) {
		$result2 = dbquery("SELECT weblink_cat_id,weblink_id,weblink_datestamp FROM ".DB_WEBLINKS." WHERE weblink_cat='".$wdata['weblink_cat_id']."' ORDER BY weblink_datestamp DESC");
		$rows2 = dbrows($result2);
		if ($rows2!=0) {
			while ($data = dbarray($result2)) {
				$content.= "\t<url>\n";
				$content.= "\t\t<loc>".$settings['siteurl']."weblinks.php?cat_id=".$data['weblink_cat_id']."&weblink_id=".$data['weblink_id']. "</loc>\n";
				$content.= "\t\t<lastmod>".makexmldate($data['weblink_datestamp'])."</lastmod>\n";
				$content.= "\t\t<priority>0.2</priority>\n";
				$content.= "\t\t<changefreq>weekly</changefreq>\n";
				$content.= "\t</url>\n";
			}
		}
	}
}

//forum kategorilerinin linki yok gerek de yok, forum cats are not required, false links
//forum kategorileri - forum categories
$result = dbquery("SELECT forum_id FROM ".DB_FORUMS." WHERE ".groupxmlaccess('forum_access')." AND forum_cat=0 ORDER BY forum_order ASC");
$rows = dbrows($result);
if ($rows!=0) {
	while ($data = dbarray($result)) {
				$content.= "\t<url>\n";
				$content.= "\t\t<loc>".$settings['siteurl']."forum/viewforum.php?forum_id=".$data['forum_id']."</loc>\n";
				//$content.= "\t\t<lastmod>".makexmldate($data['forum_lastpost'])."</lastmod>\n";
				$content.= "\t\t<priority>0.4</priority>\n";
				$content.= "\t\t<changefreq>weekly</changefreq>\n";
				$content.= "\t</url>\n";
	}
}
*/

//forumlar - forums
$result = dbquery("SELECT forum_id FROM ".DB_FORUMS." WHERE ".groupxmlaccess('forum_access')." AND forum_cat!=0 ORDER BY forum_order ASC");
$rows = dbrows($result);
if ($rows!=0) {
	while ($data = dbarray($result)) {
				$content.= "\t<url>\n";
				$content.= "\t\t<loc>".$settings['siteurl']."forum/viewforum.php?forum_id=".$data['forum_id']."</loc>\n";
				//$content.= "\t\t<lastmod>".makexmldate($data['forum_lastpost'])."</lastmod>\n";
				$content.= "\t\t<priority>".$sitemapsettings['forums_priority']."</priority>\n";
				$content.= "\t\t<changefreq>".makechangefreq($sitemapsettings['forums_changefreq'])."</changefreq>\n";
				$content.= "\t</url>\n";
	}
}

//popler forum balklar - popular threads 
$limiter=$sitemapsettings['threads_limit']?" LIMIT ".$sitemapsettings['threads_limit']:"";
$result = dbquery("
	SELECT tt.thread_id,tt.thread_lastpost FROM ".DB_THREADS." tt
	INNER JOIN ".DB_FORUMS." tf ON tt.forum_id=tf.forum_id
	WHERE ".groupxmlaccess('forum_access')."
	ORDER BY thread_postcount DESC ".$limiter
	);
$rows = dbrows($result);
if ($rows!=0) {
	while ($data = dbarray($result)) {
				$content.= "\t<url>\n";
				$content.= "\t\t<loc>".$settings['siteurl']."forum/viewthread.php?thread_id=".$data['thread_id']."</loc>\n";
				$content.= "\t\t<lastmod>".makexmldate($data['thread_lastpost'])."</lastmod>\n";
				$content.= "\t\t<priority>".$sitemapsettings['threads_priority']."</priority>\n";
				$content.= "\t\t<changefreq>".makechangefreq($sitemapsettings['threads_changefreq'])."</changefreq>\n";
				$content.= "\t</url>\n";
	}
}


$content.= "</urlset>\n";

return $content;

}

function make_sitemapxml() {
$sitemapfile=BASEDIR."sitemap.xml"; //dosyamz belirleyelim
	if (!file_exists($sitemapfile) || !is_writable($sitemapfile)) {
	return false;
	} else {
		$file=fopen($sitemapfile,"w");
		if (!fwrite($file,generate_sitemapxml())) {
			return false;
			}
		fclose($file);
		return true;
	}
}

//admin paneli form fonksiyonlar - admin panel form functions
function makechangefreq($value) {
	switch ($value) {
		case 0:
			return "daily";
			break;
		case 1:
			return "weekly";
			break;
		case 2:
			return "monthly";
			break;
		case 3:
			return "yearly";
			break;
	}
}

function makepriorityform($selectname,$value) {
$output= "<select name='".$selectname."' class='textbox'>";
	for ($i=1;$i<10;$i++) {
		$thevalue="0.$i";
		$output.= "<option".($thevalue == $value ? " selected='selected'" : "").">".$thevalue."</option>\n";
	}
	$output.= "<option".("1.0" == $value ? " selected='selected'" : "").">1.0</option>\n";
	$output.="</select>\n";
	
	return $output;
}

function makefrequencyform($selectname,$value) {
global $locale;
$output="<select name='".$selectname."' class='textbox'>\n";
	for ($i=0;$i<4;$i++) {
	$output.="<option value='".$i."'".($i == $value ? " selected='selected'" : "").">".$locale['smxml_16'][$i]."</option>";
	}
	$output.="</select>\n";

	return $output;
}


?>